#!/usr/local/bin/perl
require 5.004;
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::Diary.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
use Satsuki::Diary ();
use Satsuki::Diary_auto ();
use Satsuki::Diary_auto2 ();
use Satsuki::Diary_auto3 ();
package Satsuki::Diary;
our $DAYBOOKLIST_TABLE;
###############################################################################
# С󤫤Υåץ졼
###############################################################################
#------------------------------------------------------------------------------
# Version 1.32  Version 1.40ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v140 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	# Ģؤɲ
	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	my ($r, $c);
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		my $table     = "${diary_id}_diary";
		my $table_com = "${diary_id}_comment";
		my $table_tb  = "${diary_id}_tb";
		#---------------------------
		# 쥫κ
		#---------------------------
		if ( $DB->drop_column($table, "upnode") ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		#---------------------------
		# wikiĥɲ
		#---------------------------
		if ( $DB->add_column($table, {name => "link_key", type => "text", index => 1, unique => 1}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		if ( $DB->add_column($table, {name => "upnode", type => "text", index => 1}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		if ( $DB->add_column($table, {name => "children_cache", type => "text"}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		# for comment
		if ( $DB->add_column($table_com, {name => "diary_elink_key", type => "text"}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		# for trackback
		if ( $DB->add_column($table_tb,  {name => "diary_elink_key", type => "text"}) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		#---------------------------
		# /TBǡκ
		#---------------------------
		my $h = { search_cols => ['pkey', 'comments_all', 'tbs_all'] };
		my $list = $DB->select($table, $h);
		foreach(@$list) {
			my $pkey = $_->{pkey};
			$DB->update_match($table, {priority => 0, link_key => "0$pkey"}, 'pkey', $pkey);
			# Ƚ
			if ($_->{comments_all}) {
				$DB->update_match($table_com, {diary_elink_key => "0$pkey"}, 'diary_pkey', $pkey);
			}
			if ($_->{tbs_all}) {
				$DB->update_match($table_tb,  {diary_elink_key => "0$pkey"}, 'diary_pkey', $pkey);
			}
		}
		# κƹ
		$c += $self->{success};
	}
	# ղþκƹ
	return $self->root_daybooks_info_rebuild();
}

#------------------------------------------------------------------------------
# Version 1.22  Version 1.30ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v130 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	# Ģؤɲ
	my $h = {name => "blog_name", type => "text"};
	if ( $DB->add_column($DAYBOOKLIST_TABLE, $h) ) {
		$ROBJ->message('Internal Error(%s)', $DAYBOOKLIST_TABLE);
		return 1;
	}
	my $h = {name => "hidden", type => "flag", index => 1};
	if ( $DB->add_column($DAYBOOKLIST_TABLE, $h) ) {
		$ROBJ->message('Internal Error(%s)', $DAYBOOKLIST_TABLE . "(2)");
		return 2;
	}
	$DB->update_match($DAYBOOKLIST_TABLE, {hidden => 0});
	# ղþκƹ
	return $self->root_daybooks_info_rebuild();
}

#------------------------------------------------------------------------------
# Version 1.04  Version 1.10ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_v110 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	my $cond_func = sub {
		my $d = shift;
		if ($d->{text} =~ /<!-- Seemore -->/) { return 0; }	# ƹۤ
		return 1;	# ƹۤʤ
	};
	my ($r, $c);
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		my $table = "${diary_id}_diary";
		# бɲ
		my $h = {name => "phone_cache", type => "text"};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		$h = {name => "phone_cache_tm", type => "int", index => 1};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table); 
			$r++;
		}
		# κƹ
		$r += $self->daybook_rebuild($diary_id, $cond_func);
		$c += $self->{success};
	}
	$self->{rebuild} = $c;
	return $r;
}

#------------------------------------------------------------------------------
# 15Version 1.00 RC1 ʹ
#------------------------------------------------------------------------------
sub adiary_upgrade_for_rc1 {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	my $r;
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		# ơ֥ؤѹ
		my $table = "${diary_id}_diary";
		my $h = {name => "priority", type => "int", index => 1};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		$h = {name => "upnode", type => "int", index => 1};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table); 
			$r++;
		}
		$h = {priority => 0};
		$DB->update_match($table, $h);
		# ȥơ֥ؤѹ
		$table = "${diary_id}_comment";
		$h = {name => "pass", type => "text"};
		if ( $DB->add_column($table, $h) ) {
			$ROBJ->message('Internal Error(%s)', $table);
			$r++;
		}
		$DB->add_index($table, "hidden");
	}
	if ($r) { return $r; }
	
	# ղþκƹ
	return $self->root_daybooks_info_rebuild();
}

1;
